> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hyperspell.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Index a public website



## OpenAPI

````yaml https://api.hyperspell.com/openapi.json post /integrations/web_crawler/crawl
openapi: 3.1.0
info:
  title: Hyperspell API
  summary: >-
    Hyperspell is the memory layer for AI apps and agents. Through the API, you
    can add memories, connect data sources to index them in real-time, and
    search memories with our natural language query engine.
  termsOfService: https://hyperspell.com/blog/tos
  contact:
    name: Hyperspell
    url: https://hyperspell.com/
    email: hello@hyperspell.com
  version: 0.32.1
servers:
  - url: https://api.hyperspell.com
    description: Production
security: []
paths:
  /integrations/web_crawler/crawl:
    post:
      tags:
        - Integrations
      summary: Index a public website
      operationId: index_website_integrations_web_crawler_crawl_post
      parameters:
        - name: X-As-User
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Optionally set this header to act as a specific user when using an
              API Key, equivalent to first exchanging the API Key for a User
              Token
            title: X-As-User
          description: >-
            Optionally set this header to act as a specific user when using an
            API Key, equivalent to first exchanging the API Key for a User Token
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/WebsiteIndexParams'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WebsiteCrawlProgress'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKey: []
components:
  schemas:
    WebsiteIndexParams:
      properties:
        share:
          anyOf:
            - type: string
              enum:
                - personal
                - shared
            - type: 'null'
          title: Share
          description: >-
            Visibility for new pages. New websites default to shared; existing
            websites keep their saved choice.
        url:
          type: string
          maxLength: 2048
          minLength: 1
          title: Url
        max_depth:
          type: integer
          maximum: 5
          minimum: 0
          title: Max Depth
          default: 3
        limit:
          type: integer
          maximum: 1000
          minimum: 1
          title: Limit
          default: 100
      type: object
      required:
        - url
      title: WebsiteIndexParams
    WebsiteCrawlProgress:
      properties:
        url:
          type: string
          title: Url
          default: ''
        status:
          type: string
          title: Status
          default: queued
        discovered:
          anyOf:
            - type: integer
            - type: 'null'
          title: Discovered
          default: 0
        indexed:
          anyOf:
            - type: integer
            - type: 'null'
          title: Indexed
          default: 0
        failed:
          anyOf:
            - type: integer
            - type: 'null'
          title: Failed
          default: 0
        limit:
          type: integer
          title: Limit
          default: 0
        limit_reached:
          type: boolean
          title: Limit Reached
          default: false
        errors:
          items:
            type: string
          type: array
          title: Errors
        duplicates:
          type: integer
          title: Duplicates
          default: 0
        run_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Run Id
      type: object
      title: WebsiteCrawlProgress
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKey:
      type: http
      description: >-
        API Key or JWT User Token. If using an API Key, set the X-As-User header
        to act as a specific user. A JWT User Token is always scoped to a
        specific user.
      scheme: bearer
      bearerFormat: Bearer <token>

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.